
#include<iostream>
std::ostream out=std::cerr;
//std::istream in=std::cin;

#include<fstream>
std::ifstream in1("Meta.in");
std::ifstream in("Maximum.pas");

/*
program maximum(input,output);
var a,b,c: integer;
begin
   readln(a,b,c);
   if c > b then
      if c > a then
         writeln(c)
      else
         writeln(a)
   else
      if b > a then
         writeln(b)
      else
         writeln(a)
end.
*/

// Errors

const UnknownIdentifier=1;
const SyntaxError=2;
const RedundantComparison=3;
const UnexpectedEndOfFile=4;
const LogicalError=5;
const InvalidNameOfProgram=6;
const TooMuchVariables=7;
const Duplicate=8;
const InvalidVarName=9;
const WrongVarsNumber=10;
const OK=0;

enum Toks {lparths,rparths,lbrace,rbrace,comma,colon,
		dot,semicolon,less,greater,string,other};

class token{
	Toks Cat;
	char Name[32];
public:
	friend std::istream & operator>>(std::istream &,token &);
	friend bool invalid(const token & T,int N);
	bool operator==(Toks T){return Cat==T;};
	bool operator!=(Toks T){return Cat!=T;};
	bool operator==(char *C);
	bool operator!=(char *C){return !(*this==C);};
	char name(){return Name[0];};
};


inline char upper(char C) {
	if (C>='a' && C<='z') return (char)(C-32);
	else return C;
}


bool token::operator ==(char *C){
	if (Cat!=string) return false;
	int i=0;
	do {
		if (upper(Name[i])!=upper(C[i])) return false;
		else i++;}
	while (Name[i]!=0&&C[i]!=0);
	return true;
}

inline bool IsLetter(char C){return (C>='A' && C<='Z') ||
			(C>='a' && C<='z');}

std::istream & operator>>(std::istream &IS,token & T){
	char C,Cn;
	int i;
	if(!(IS.get(C))) return IS;
	while (C<=' ') if(!(IS.get(C))) return IS;
	if (IsLetter(C)) {
		T.Cat=string;
		T.Name[i=0]=C;
		Cn=IS.peek();
		while (IsLetter(Cn)){
			IS.get(T.Name[++i]);
			Cn=IS.peek();
		};
		T.Name[++i]=0;
		return IS;
	};
	switch (C){
	case '<': T.Cat=less; break;
	case '>': T.Cat=greater; break;
	case '(': T.Cat=lparths; break;
	case ')': T.Cat=rparths; break;
	case '{': T.Cat=lbrace; break;
	case '}': T.Cat=rbrace; break;
	case '.': T.Cat=dot; break;
	case ',': T.Cat=comma; break;
	case ';': T.Cat=semicolon; break;
	case ':': T.Cat=colon; break;
	default: T.Cat=other;
	};
	return IS;
}

template<class T>
class Stack{
protected:
	T *Buffer;
	int Ss;
public:
	Stack(int N);
	~Stack();
	T pop();
	void push(T );
	int length(){return Ss;};
	bool contains(T C);
	bool empty(){return Ss==0;};
	friend std::ostream & operator<<(std::ostream &,const Stack<T>&);
};


template<class T>
std::ostream & operator<<(std::ostream &OS,const Stack<T>&S){
	for(int i=0;i<S.Ss;i++) OS<<S.Buffer[i];
	return OS;
}



template<class T>
bool Stack<T>::contains(T C){
	int i;
	for (i=0;i<Ss;i++) if (Buffer[i]==C) return true;
	return false;
}

template<class T>
Stack<T>::Stack(int N){
	Buffer=new T[N];
	Ss=0;
	return;
};

template<class T>
Stack<T>::~Stack(){
	delete Buffer;
	return;
}

template<class T>
T Stack<T>::pop(){
	return Buffer[--Ss];
}

template<class T>
void Stack<T>::push(T K){
	Buffer[Ss++]=K;
	return;
}


bool invalid(const token &T,int N){
	char L=char('A'+N);
	char l=char('a'+N);
	if (T.Name[1]!=0) return true;
	if (T.Name[0]>='A' && T.Name[0]<L) return false;
	if (T.Name[0]>='a' && T.Name[0]<l) return false;
	return true;
};

int ReadVars(int N){
	token T;
	char C;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="Var") return SyntaxError;
	Stack<char> Vars(N);
	for (int i=0;i<N-1;i++){
		if(!(in>>T)) return UnexpectedEndOfFile;
		if (T!=string) return SyntaxError;
		if (invalid(T,N)) return InvalidVarName;
		C=upper(T.name());
		if (Vars.contains(C)) return Duplicate;
		Vars.push(C);
		if(!(in>>T)) return UnexpectedEndOfFile;
		if (T!=comma) return SyntaxError;
	};
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=string) return SyntaxError;
	if (invalid(T,N)) return InvalidVarName;
	C=upper(T.name());
	if (Vars.contains(C)) return Duplicate;
	if (Vars.length()!=N-1) return WrongVarsNumber;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=colon) return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="integer") return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=semicolon) return SyntaxError;
	return OK;
}

int ReadProgram(){
	token T;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="program") return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="maximum") return InvalidNameOfProgram;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=lparths) return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="input") return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=comma) return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="output") return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=rparths) return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=semicolon) return SyntaxError;
	return OK;
}

int ReadBegin(){
	token T;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="begin") return SyntaxError;
	return OK;
};

int ReadReadln(int N){
	token T;
	char C;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!="readln") return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=lparths) return SyntaxError;
	Stack<char> Vars(N);
	for (int i=0;i<N-1;i++){
		if(!(in>>T)) return UnexpectedEndOfFile;
		if (T!=string) return SyntaxError;
		if (invalid(T,N)) return InvalidVarName;
		C=upper(T.name());
		if (Vars.contains(C)) return Duplicate;
		Vars.push(C);
		if(!(in>>T)) return UnexpectedEndOfFile;
		if (T!=comma) return SyntaxError;
	};
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=string) return SyntaxError;
	if (invalid(T,N)) return InvalidVarName;
	C=upper(T.name());
	if (Vars.contains(C)) return Duplicate;
	if (Vars.length()!=N-1) return WrongVarsNumber;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=rparths) return SyntaxError;
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=semicolon) return SyntaxError;
	return OK;
}

class tree{
private: 
	char Vertex[2];
	tree *Left;
	tree *Right;
public:
//	~tree(){
//		if (Left
	tree(){
		Left=Right=NULL;
		return;
	};
	tree(char C1,char C2=0){
		Left=Right=NULL;
		Vertex[0]=C1;
		Vertex[1]=C2;
		return;
	};
	tree*& left(){return Left;};
	tree*& right(){return Right;};
	friend std::ostream& operator<<(std::ostream&,const tree&);
	bool check(int,char C);
};


bool tree::check(int N,char C){
	if (Vertex[1]==0){
		if (Vertex[0]==C) return true;
		else return false;
	}
	else {
		if (Vertex[1]==C){
			if (Left==NULL) return false;
				return Left->check(N-1,C);
		}
		else{
			if(Vertex[0]==C){
				if (Right==NULL) return false;
				return Right->check(N-1,C);
			}
			else{
				if(Left==NULL ||Right==NULL) return false;
				return Left->check(N-1,C)&& Right->check(N-1,C);
			}
		}
	};
}




std::ostream& operator<<(std::ostream&OS,const tree&T){
	if(T.Left!=NULL) OS<<*T.Left<<std::endl;
	OS<<'\t'<<T.Vertex[0]<<'.'<<T.Vertex[1]<<std::endl;
	if(T.Right!=NULL) OS<<*T.Right<<std::endl;
	return OS;
}


int ReadBody(int N,tree* &Tr){
	const IF=1;
	const ELSE=2;
	const WRITELN=3;
	int State=0;
	token T;
	char Cl,Cr;
	Stack<char> Known(N);
	Stack<char> UnKnown(N);
	Stack<char> Dirs(N);
	Stack<tree *> Trees(N);
	Tr=NULL;
	if(!(in>>T)) return UnexpectedEndOfFile;
	while (T!="end"){
		if(T=="if"){
			Dirs.push('r');
			if (State==WRITELN) return SyntaxError;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if(invalid(T,N)) return SyntaxError;
			Cl=upper(T.name());
			if(Known.contains(Cl)) return RedundantComparison;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if(T==greater){
				if(!(in>>T)) return UnexpectedEndOfFile;
				if(invalid(T,N)) return SyntaxError;
				Cr=upper(T.name());
				if(Cl==Cr) return RedundantComparison;
				if(Known.contains(Cr)) return RedundantComparison;
				if(!(in>>T)) return UnexpectedEndOfFile;
				if(T!="then") return SyntaxError;
				Known.push(Cr);
				UnKnown.push(Cl);
				if (Tr==NULL) Tr= new tree(Cr,Cl);
				else{
					Trees.push(Tr);
					if (State==IF){
						Tr->left()=new tree(Cr,Cl);
						Tr=Tr->left();
					};
					if (State==ELSE){
						Tr->right()= new tree(Cr,Cl);
						Tr=Tr->right();
					};
				};
				if(!(in>>T)) return UnexpectedEndOfFile;
				State=IF;
				continue;
			};
			if(T==less){
				if(!(in>>T)) return UnexpectedEndOfFile;
				if(invalid(T,N)) return SyntaxError;
				Cr=upper(T.name());
				if(Cl==Cr) return RedundantComparison;
				if(Known.contains(Cr)) return RedundantComparison;
				if(!(in>>T)) return UnexpectedEndOfFile;
				if(T!="then") return SyntaxError;
				Known.push(Cl);
				UnKnown.push(Cr);
				if (Tr==NULL) Tr= new tree(Cl,Cr);
				else{
					Trees.push(Tr);
					if (State==IF){
						Tr->left()=new tree(Cl,Cr);
						Tr=Tr->left();
					};
					if (State==ELSE){
						Tr->right()= new tree(Cl,Cr);
						Tr=Tr->right();
					};
				};
				if(!(in>>T)) return UnexpectedEndOfFile;
				State=IF;
				continue;
			}
			else return SyntaxError;
		};
		if (T=="Else"){
			if(State==0) return SyntaxError;
			State=ELSE;
			if (Dirs.empty()) return SyntaxError;
			while(Dirs.pop()=='l') {
				Known.pop();
				Tr=Trees.pop();
			};
			Known.pop();
			Dirs.push('l');
			Cr=UnKnown.pop();
			Known.push(Cr);
			if(!(in>>T)) return UnexpectedEndOfFile;
			continue;
		};
		if (T=="writeln"){
			if (State==WRITELN) return SyntaxError;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if(T!=lparths) return SyntaxError;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if(invalid(T,N)) return SyntaxError;
			Cr=upper(T.name());
			if(Known.contains(Cr)) return LogicalError;
			if(Known.length()<N-1) return LogicalError;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if(T!=rparths) return SyntaxError;
			if(!(in>>T)) return UnexpectedEndOfFile;
			if (State==IF) Tr->left()=new tree(Cr);
			if (State==0) Tr= new tree(Cr);
			if (State==ELSE) Tr->right()=new tree(Cr);
			State=WRITELN;
			continue;
		}
		else return SyntaxError;
	};
	if(!(in>>T)) return UnexpectedEndOfFile;
	if (T!=dot) return SyntaxError;
	while (!Trees.empty()) Tr=Trees.pop();
	return OK;
}


int CheckBody(int N,tree*Tr){
	char C;
	if (Tr==NULL) return LogicalError;
	for (C='A';C<(char)('A'+N);C++) if(! Tr->check(N,C)) return LogicalError;
	return OK;
}


int main(){
	int N;
	in1>>N;
	in1.close();
	int Error;
	try{
		Error=ReadProgram();
		if (Error) throw Error;
		Error=ReadVars(N);
		if (Error) throw Error;
		Error=ReadBegin();
		if (Error) throw Error;
		Error=ReadReadln(N);
		if (Error) throw Error;
		tree *Tr=NULL;
		Error=ReadBody(N,Tr);
		if (Error) throw Error;
		in.close();
		Error=CheckBody(N,Tr);
		if (Error) throw Error;
		out<<OK<<std::endl;
		return OK;
	}
	catch(int Error){
		out<<"Error "<<Error<<std::endl;
		in.close();
		return Error;
	};
}

