//#include<iostream>
//std::istream in=std::cin;
//std::ostream out=std::cout;

#include<fstream>
std::ifstream in("Meta.in");
std::ofstream out("Maximum.pas");

enum Direction {left,right};

class Stack{
protected:
	char *Buffer;
	int Ss;
public:
	Stack(int N);
	~Stack();
	char pop();
	void push(char );
	int length(){return Ss;};
};

Stack::Stack(int N){
	Buffer=new char[N];
	Ss=0;
	return;
};

Stack::~Stack(){
	delete Buffer;
	return;
}

char Stack::pop(){
	return Buffer[--Ss];
}

void Stack::push(char K){
	Buffer[Ss++]=K;
	return;
}

class tree{
private:
	Direction *Dirs;
	char Max;
	int N;
	int K;
	Stack *Known, *Unknown;
	bool IsUp(){return K<N-1;};
	void Up();
	void Work();
public:
	void ULW();
	bool IsDown(){return K>0;};
	bool IsRight(){return Dirs[K-1]==left;};
	void Down();
	void Right();
	tree(int);
	~tree();
	friend std::ostream& operator <<(std::ostream &OS,const tree&T);
};


void tree::Work(){
	int i;
	for(i=0;i<N;i++) out<<"   ";
	out<<"writeln("<<Max<<")\n";
	return;
}

void tree::Up(){
	int i;
	char C;
	for (i=0;i<=K;i++) out<<"   ";
	C=Unknown->pop();
	out<<"if "<<Max<<" > "<<C<<" then\n";
	Dirs[K++]=left;
	Known->push(C);
	return;
}

void tree::Down(){
	char C;
	C=Known->pop();
	K--;
	Unknown->push(Max);
	Max=C;
	return;
}


void tree::Right(){
	int i;
	char C;
	for (i=0;i<K;i++) out<<"   ";
	out<<"else\n";
	C=Known->pop();
	Known->push(Max);
	Max=C;
	Dirs[K-1]=right;
	return;
};

tree::tree(int Nn){
	N=Nn;
	K=0;
	Dirs= new Direction[N];
	Known= new Stack(N);
	Unknown=new Stack(N);
	for (char C='a';C<char('a'+N-1);) Unknown->push(C++);
	Max=C;
	return;
};

tree::~tree(){
	delete[] Dirs;
	delete Known;
	delete Unknown;
	return;
};


void tree::ULW(){
	while (IsUp()) Up();
	Work();
	return;
}


std::ostream& operator <<(std::ostream &OS,const tree&T){
	char i;
	for (i='a';i<(char)('a'+T.N-1);i++) OS<<i<<',';
	OS<<i;
	return OS;
}


int main(){
	int N;
	in>>N;
	in.close();
	out<<"program maximum(input,output);\n";
	if (N==-1) out<<"var a: integer;\nbegin\n   readln(a);\n   writeln(a)\nend.\n";
	else {
		tree T(N);
		out<<"var "<<T<<": integer;\nbegin\n   readln("<<T<<");\n";
		T.ULW();
		while (T.IsDown()){
			if (T.IsRight()){
				T.Right();
				T.ULW();
			}
			else T.Down();
		};
		out<<"end.\n";
	};
	out.close();
	return 0;
}


